/*
 * HelloMidlet.java
 *
 * Created on 6 Сентябрь 2006 г., 22:14
 */

package hello;

import java.util.Vector;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author evgs
 */
public class HelloMidlet extends MIDlet implements CommandListener {
    
    /** Creates a new instance of HelloMidlet */
    public HelloMidlet() {
    }
    
    private Form helloForm;//GEN-BEGIN:MVDFields
    private StringItem totalString;
    private Command exitCommand;
    private Command memFill;
    private StringItem freeString;
    private StringItem allocated;//GEN-END:MVDFields
    
    private Vector ram=new Vector();
    int nAllocated;
//GEN-LINE:MVDMethods

    /** This method initializes UI of the application.//GEN-BEGIN:MVDInitBegin
     */
    private void initialize() {//GEN-END:MVDInitBegin
        // Insert pre-init code here
        getDisplay().setCurrent(get_helloForm());//GEN-LINE:MVDInitInit
        // Insert post-init code here
    }//GEN-LINE:MVDInitEnd
    
    /** Called by the system to indicate that a command has been invoked on a particular displayable.//GEN-BEGIN:MVDCABegin
     * @param command the Command that ws invoked
     * @param displayable the Displayable on which the command was invoked
     */
    public void commandAction(Command command, Displayable displayable) {//GEN-END:MVDCABegin
        // Insert global pre-action code here
        if (displayable == helloForm) {//GEN-BEGIN:MVDCABody
            if (command == exitCommand) {//GEN-END:MVDCABody
                // Insert pre-action code here
                exitMIDlet();//GEN-LINE:MVDCAAction3
                // Insert post-action code here
            } else if (command == memFill) {//GEN-LINE:MVDCACase3
                // Insert pre-action code here
                System.gc();
                ram.addElement(new byte[20480]);
                nAllocated+=20;
                
                freeString.setText( String.valueOf(Runtime.getRuntime().freeMemory()>>10) );
                totalString.setText( String.valueOf(Runtime.getRuntime().totalMemory()>>10) );
                allocated.setText( String.valueOf(nAllocated));
                // Do nothing//GEN-LINE:MVDCAAction7
                // Insert post-action code here
            }//GEN-BEGIN:MVDCACase7
        }//GEN-END:MVDCACase7
        // Insert global post-action code here
}//GEN-LINE:MVDCAEnd
    
    /**
     * This method should return an instance of the display.
     */
    public Display getDisplay() {//GEN-FIRST:MVDGetDisplay
        return Display.getDisplay(this);
    }//GEN-LAST:MVDGetDisplay
    
    /**
     * This method should exit the midlet.
     */
    public void exitMIDlet() {//GEN-FIRST:MVDExitMidlet
        getDisplay().setCurrent(null);
        destroyApp(true);
        notifyDestroyed();
    }//GEN-LAST:MVDExitMidlet
    
    /** This method returns instance for helloForm component and should be called instead of accessing helloForm field directly.//GEN-BEGIN:MVDGetBegin2
     * @return Instance for helloForm component
     */
    public Form get_helloForm() {
        if (helloForm == null) {//GEN-END:MVDGetBegin2
            // Insert pre-init code here
            helloForm = new Form(null, new Item[] {//GEN-BEGIN:MVDGetInit2
                get_totalString(),
                get_freeString(),
                get_allocated()
            });
            helloForm.addCommand(get_exitCommand());
            helloForm.addCommand(get_memFill());
            helloForm.setCommandListener(this);//GEN-END:MVDGetInit2
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd2
        return helloForm;
    }//GEN-END:MVDGetEnd2
    
    /** This method returns instance for totalString component and should be called instead of accessing totalString field directly.//GEN-BEGIN:MVDGetBegin4
     * @return Instance for totalString component
     */
    public StringItem get_totalString() {
        if (totalString == null) {//GEN-END:MVDGetBegin4
            // Insert pre-init code here
            totalString = new StringItem("Total", "not available");//GEN-LINE:MVDGetInit4
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd4
        return totalString;
    }//GEN-END:MVDGetEnd4
    
    /** This method returns instance for exitCommand component and should be called instead of accessing exitCommand field directly.//GEN-BEGIN:MVDGetBegin5
     * @return Instance for exitCommand component
     */
    public Command get_exitCommand() {
        if (exitCommand == null) {//GEN-END:MVDGetBegin5
            // Insert pre-init code here
            exitCommand = new Command("Exit", Command.EXIT, 1);//GEN-LINE:MVDGetInit5
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd5
        return exitCommand;
    }//GEN-END:MVDGetEnd5
    /** This method returns instance for freeString component and should be called instead of accessing freeString field directly.//GEN-BEGIN:MVDGetBegin8
     * @return Instance for freeString component
     */
    public StringItem get_freeString() {
        if (freeString == null) {//GEN-END:MVDGetBegin8
            // Insert pre-init code here
            freeString = new StringItem("Free", "not available");//GEN-LINE:MVDGetInit8
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd8
        return freeString;
    }//GEN-END:MVDGetEnd8

    /** This method returns instance for memFill component and should be called instead of accessing memFill field directly.//GEN-BEGIN:MVDGetBegin6
     * @return Instance for memFill component
     */
    public Command get_memFill() {
        if (memFill == null) {//GEN-END:MVDGetBegin6
            // Insert pre-init code here
            memFill = new Command("+20K", Command.SCREEN, 1);//GEN-LINE:MVDGetInit6
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd6
        return memFill;
    }//GEN-END:MVDGetEnd6

    /** This method returns instance for allocated component and should be called instead of accessing allocated field directly.//GEN-BEGIN:MVDGetBegin9
     * @return Instance for allocated component
     */
    public StringItem get_allocated() {
        if (allocated == null) {//GEN-END:MVDGetBegin9
            // Insert pre-init code here
            allocated = new StringItem("Allocated", "not available");//GEN-LINE:MVDGetInit9
            // Insert post-init code here
        }//GEN-BEGIN:MVDGetEnd9
        return allocated;
    }//GEN-END:MVDGetEnd9
    
    public void startApp() {
        initialize();
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) {
    }
    
}
